=begin
#Payout Orchestrator API

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.3

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'cgi'

module Yapstone
  class PayoutsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    #                      Cancels the given deposit advice if it has not yet been processed. Note that a deposit advice                     cannot be cancelled after it has been reconciled via the corresponding bank account activity record.
    # @param deposit_id [String] Primary key for a single deposit record (assigned by YapStone)
    # @param cancel_deposit_request [CancelDepositRequest] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def cancel_deposit(deposit_id, cancel_deposit_request, opts = {})
      cancel_deposit_with_http_info(deposit_id, cancel_deposit_request, opts)
      nil
    end

    #                      Cancels the given deposit advice if it has not yet been processed. Note that a deposit advice                     cannot be cancelled after it has been reconciled via the corresponding bank account activity record.
    # @param deposit_id [String] Primary key for a single deposit record (assigned by YapStone)
    # @param cancel_deposit_request [CancelDepositRequest] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def cancel_deposit_with_http_info(deposit_id, cancel_deposit_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.cancel_deposit ...'
      end
      # verify the required parameter 'deposit_id' is set
      if @api_client.config.client_side_validation && deposit_id.nil?
        fail ArgumentError, "Missing the required parameter 'deposit_id' when calling PayoutsApi.cancel_deposit"
      end
      # verify the required parameter 'cancel_deposit_request' is set
      if @api_client.config.client_side_validation && cancel_deposit_request.nil?
        fail ArgumentError, "Missing the required parameter 'cancel_deposit_request' when calling PayoutsApi.cancel_deposit"
      end
      # resource path
      local_var_path = '/payouts/v1/deposits/{depositId}'.sub('{' + 'depositId' + '}', CGI.escape(deposit_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(cancel_deposit_request) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#cancel_deposit\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    #                      Cancel Disbursement - Cancels the given disbursement if it has not yet been processed. Note that a                     disbursement cannot be cancelled after it has been submitted for payment to the downstream                     processor.                     Reverse Disbursement - Submits a full (or partial) disbursement for funds that were originally                     retrieved via the given transactionId recapture order. The resulting transactionId represents the                     linked disbursement.
    # @param transaction_id [String] Primary key for a single disbursement record (assigned by YapStone)
    # @param cancel_request [CancelRequest] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def cancel_disbursement(transaction_id, cancel_request, opts = {})
      cancel_disbursement_with_http_info(transaction_id, cancel_request, opts)
      nil
    end

    #                      Cancel Disbursement - Cancels the given disbursement if it has not yet been processed. Note that a                     disbursement cannot be cancelled after it has been submitted for payment to the downstream                     processor.                     Reverse Disbursement - Submits a full (or partial) disbursement for funds that were originally                     retrieved via the given transactionId recapture order. The resulting transactionId represents the                     linked disbursement.
    # @param transaction_id [String] Primary key for a single disbursement record (assigned by YapStone)
    # @param cancel_request [CancelRequest] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def cancel_disbursement_with_http_info(transaction_id, cancel_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.cancel_disbursement ...'
      end
      # verify the required parameter 'transaction_id' is set
      if @api_client.config.client_side_validation && transaction_id.nil?
        fail ArgumentError, "Missing the required parameter 'transaction_id' when calling PayoutsApi.cancel_disbursement"
      end
      # verify the required parameter 'cancel_request' is set
      if @api_client.config.client_side_validation && cancel_request.nil?
        fail ArgumentError, "Missing the required parameter 'cancel_request' when calling PayoutsApi.cancel_disbursement"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/{transactionId}'.sub('{' + 'transactionId' + '}', CGI.escape(transaction_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(cancel_request) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#cancel_disbursement\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    #                      Reverse Reimbursement - Submits a full (or partial) disbursement for funds that were originally                     retrieved via the given transactionId recapture order. The resulting transactionId represents the                     linked reimbursement.
    # @param transaction_id [String] Primary key for a single reimbursement record (assigned by YapStone)
    # @param cancel_request [CancelRequest] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def cancel_reimbursement(transaction_id, cancel_request, opts = {})
      cancel_reimbursement_with_http_info(transaction_id, cancel_request, opts)
      nil
    end

    #                      Reverse Reimbursement - Submits a full (or partial) disbursement for funds that were originally                     retrieved via the given transactionId recapture order. The resulting transactionId represents the                     linked reimbursement.
    # @param transaction_id [String] Primary key for a single reimbursement record (assigned by YapStone)
    # @param cancel_request [CancelRequest] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def cancel_reimbursement_with_http_info(transaction_id, cancel_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.cancel_reimbursement ...'
      end
      # verify the required parameter 'transaction_id' is set
      if @api_client.config.client_side_validation && transaction_id.nil?
        fail ArgumentError, "Missing the required parameter 'transaction_id' when calling PayoutsApi.cancel_reimbursement"
      end
      # verify the required parameter 'cancel_request' is set
      if @api_client.config.client_side_validation && cancel_request.nil?
        fail ArgumentError, "Missing the required parameter 'cancel_request' when calling PayoutsApi.cancel_reimbursement"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/{transactionId}/cancel'.sub('{' + 'transactionId' + '}', CGI.escape(transaction_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(cancel_request) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#cancel_reimbursement\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    #                      Notifies YapStone that a deposit has been initiated by the Marketplace to provide funds for                     future disbursement requests. This call will create a pending deposit record that will be cleared                     when the corresponding transaction is confirmed by the acquiring bank (typically 1-3 days).                     Disbursement requests received against pending funds will be released for processing when the                     deposit is cleared.
    # @param deposit_request [DepositRequest] Request describes one or more pending deposits for the given currency.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def create_deposit(deposit_request, opts = {})
      create_deposit_with_http_info(deposit_request, opts)
      nil
    end

    #                      Notifies YapStone that a deposit has been initiated by the Marketplace to provide funds for                     future disbursement requests. This call will create a pending deposit record that will be cleared                     when the corresponding transaction is confirmed by the acquiring bank (typically 1-3 days).                     Disbursement requests received against pending funds will be released for processing when the                     deposit is cleared.
    # @param deposit_request [DepositRequest] Request describes one or more pending deposits for the given currency.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def create_deposit_with_http_info(deposit_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.create_deposit ...'
      end
      # verify the required parameter 'deposit_request' is set
      if @api_client.config.client_side_validation && deposit_request.nil?
        fail ArgumentError, "Missing the required parameter 'deposit_request' when calling PayoutsApi.create_deposit"
      end
      # resource path
      local_var_path = '/payouts/v1/deposits'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deposit_request) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#create_deposit\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    #                      Retrieves the funding position for the Marketplace for each supported currency. If the optional                     query parameter is provided, the response will include only the specified currency (EUR, GBP, USD).
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the balances. If not passed default marketplace                        from app token will be used
    # @option opts [String] :currency The currency for the balance inquiry (returns all by default)
    # @return [PoolListResponse]
    def get_balances(opts = {})
      data, _status_code, _headers = get_balances_with_http_info(opts)
      data
    end

    #                      Retrieves the funding position for the Marketplace for each supported currency. If the optional                     query parameter is provided, the response will include only the specified currency (EUR, GBP, USD).
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the balances. If not passed default marketplace                        from app token will be used
    # @option opts [String] :currency The currency for the balance inquiry (returns all by default)
    # @return [Array<(PoolListResponse, Integer, Hash)>] PoolListResponse data, response status code and response headers
    def get_balances_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_balances ...'
      end
      # resource path
      local_var_path = '/payouts/v1/balances'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?
      query_params[:'currency'] = opts[:'currency'] if !opts[:'currency'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PoolListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_balances\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns the deposit detail and status history for the given depositId.
    # @param deposit_id [String] Primary key for a single deposit record (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @return [Deposit]
    def get_deposit(deposit_id, opts = {})
      data, _status_code, _headers = get_deposit_with_http_info(deposit_id, opts)
      data
    end

    # Returns the deposit detail and status history for the given depositId.
    # @param deposit_id [String] Primary key for a single deposit record (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @return [Array<(Deposit, Integer, Hash)>] Deposit data, response status code and response headers
    def get_deposit_with_http_info(deposit_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_deposit ...'
      end
      # verify the required parameter 'deposit_id' is set
      if @api_client.config.client_side_validation && deposit_id.nil?
        fail ArgumentError, "Missing the required parameter 'deposit_id' when calling PayoutsApi.get_deposit"
      end
      # resource path
      local_var_path = '/payouts/v1/deposits/{depositId}'.sub('{' + 'depositId' + '}', CGI.escape(deposit_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Deposit' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_deposit\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all pool activities matching given bank reference tag.
    # @param bank_reference_tag [String] Partial bank reference identifier for a single deposit record
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [DepositListResponse]
    def get_deposits_by_bank_reference_tag(bank_reference_tag, opts = {})
      data, _status_code, _headers = get_deposits_by_bank_reference_tag_with_http_info(bank_reference_tag, opts)
      data
    end

    # Returns all pool activities matching given bank reference tag.
    # @param bank_reference_tag [String] Partial bank reference identifier for a single deposit record
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [Array<(DepositListResponse, Integer, Hash)>] DepositListResponse data, response status code and response headers
    def get_deposits_by_bank_reference_tag_with_http_info(bank_reference_tag, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_deposits_by_bank_reference_tag ...'
      end
      # verify the required parameter 'bank_reference_tag' is set
      if @api_client.config.client_side_validation && bank_reference_tag.nil?
        fail ArgumentError, "Missing the required parameter 'bank_reference_tag' when calling PayoutsApi.get_deposits_by_bank_reference_tag"
      end
      # resource path
      local_var_path = '/payouts/v1/deposits/bankReference/{bankReferenceTag}'.sub('{' + 'bankReferenceTag' + '}', CGI.escape(bank_reference_tag.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DepositListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_deposits_by_bank_reference_tag\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all pool activities matching given client unique transaction id.
    # @param client_unique_txn_id [String] Alternate key for a single deposit record (assigned by Marketplace)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [DepositListResponse]
    def get_deposits_by_client_unique_txn_id(client_unique_txn_id, opts = {})
      data, _status_code, _headers = get_deposits_by_client_unique_txn_id_with_http_info(client_unique_txn_id, opts)
      data
    end

    # Returns all pool activities matching given client unique transaction id.
    # @param client_unique_txn_id [String] Alternate key for a single deposit record (assigned by Marketplace)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [Array<(DepositListResponse, Integer, Hash)>] DepositListResponse data, response status code and response headers
    def get_deposits_by_client_unique_txn_id_with_http_info(client_unique_txn_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_deposits_by_client_unique_txn_id ...'
      end
      # verify the required parameter 'client_unique_txn_id' is set
      if @api_client.config.client_side_validation && client_unique_txn_id.nil?
        fail ArgumentError, "Missing the required parameter 'client_unique_txn_id' when calling PayoutsApi.get_deposits_by_client_unique_txn_id"
      end
      # resource path
      local_var_path = '/payouts/v1/deposits/clientId/{clientUniqueTxnId}'.sub('{' + 'clientUniqueTxnId' + '}', CGI.escape(client_unique_txn_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DepositListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_deposits_by_client_unique_txn_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all pool activities matching given client correlation id.
    # @param client_correlation_id [String] Correlation identifier assigned to one or more deposits by the Marketplace
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [DepositListResponse]
    def get_deposits_by_correlation_id(client_correlation_id, opts = {})
      data, _status_code, _headers = get_deposits_by_correlation_id_with_http_info(client_correlation_id, opts)
      data
    end

    # Returns all pool activities matching given client correlation id.
    # @param client_correlation_id [String] Correlation identifier assigned to one or more deposits by the Marketplace
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [Array<(DepositListResponse, Integer, Hash)>] DepositListResponse data, response status code and response headers
    def get_deposits_by_correlation_id_with_http_info(client_correlation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_deposits_by_correlation_id ...'
      end
      # verify the required parameter 'client_correlation_id' is set
      if @api_client.config.client_side_validation && client_correlation_id.nil?
        fail ArgumentError, "Missing the required parameter 'client_correlation_id' when calling PayoutsApi.get_deposits_by_correlation_id"
      end
      # resource path
      local_var_path = '/payouts/v1/deposits/correlation/{clientCorrelationId}'.sub('{' + 'clientCorrelationId' + '}', CGI.escape(client_correlation_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DepositListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_deposits_by_correlation_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all pool activities matching given client correlation id and status.
    # @param client_correlation_id [String] Correlation identifier assigned to one or more deposits by the Marketplace
    # @param current_status [String] Current deposit status of the pool activity
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [DepositListResponse]
    def get_deposits_by_correlation_id_and_status(client_correlation_id, current_status, opts = {})
      data, _status_code, _headers = get_deposits_by_correlation_id_and_status_with_http_info(client_correlation_id, current_status, opts)
      data
    end

    # Returns all pool activities matching given client correlation id and status.
    # @param client_correlation_id [String] Correlation identifier assigned to one or more deposits by the Marketplace
    # @param current_status [String] Current deposit status of the pool activity
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [Array<(DepositListResponse, Integer, Hash)>] DepositListResponse data, response status code and response headers
    def get_deposits_by_correlation_id_and_status_with_http_info(client_correlation_id, current_status, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_deposits_by_correlation_id_and_status ...'
      end
      # verify the required parameter 'client_correlation_id' is set
      if @api_client.config.client_side_validation && client_correlation_id.nil?
        fail ArgumentError, "Missing the required parameter 'client_correlation_id' when calling PayoutsApi.get_deposits_by_correlation_id_and_status"
      end
      # verify the required parameter 'current_status' is set
      if @api_client.config.client_side_validation && current_status.nil?
        fail ArgumentError, "Missing the required parameter 'current_status' when calling PayoutsApi.get_deposits_by_correlation_id_and_status"
      end
      # resource path
      local_var_path = '/payouts/v1/deposits/correlation/{clientCorrelationId}/status/{currentStatus}'.sub('{' + 'clientCorrelationId' + '}', CGI.escape(client_correlation_id.to_s).gsub('%2F', '/')).sub('{' + 'currentStatus' + '}', CGI.escape(current_status.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DepositListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_deposits_by_correlation_id_and_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all pool activities matching given currency.
    # @param currency [String] The currency for a set of deposits (EUR, GBP, USD)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [DepositListResponse]
    def get_deposits_by_currency(currency, opts = {})
      data, _status_code, _headers = get_deposits_by_currency_with_http_info(currency, opts)
      data
    end

    # Returns all pool activities matching given currency.
    # @param currency [String] The currency for a set of deposits (EUR, GBP, USD)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [Array<(DepositListResponse, Integer, Hash)>] DepositListResponse data, response status code and response headers
    def get_deposits_by_currency_with_http_info(currency, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_deposits_by_currency ...'
      end
      # verify the required parameter 'currency' is set
      if @api_client.config.client_side_validation && currency.nil?
        fail ArgumentError, "Missing the required parameter 'currency' when calling PayoutsApi.get_deposits_by_currency"
      end
      # resource path
      local_var_path = '/payouts/v1/deposits/currency/{currency}'.sub('{' + 'currency' + '}', CGI.escape(currency.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DepositListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_deposits_by_currency\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all pool activities matching given current status.
    # @param current_status [String] Current deposit status of the pool activity
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [DepositListResponse]
    def get_deposits_by_status(current_status, opts = {})
      data, _status_code, _headers = get_deposits_by_status_with_http_info(current_status, opts)
      data
    end

    # Returns all pool activities matching given current status.
    # @param current_status [String] Current deposit status of the pool activity
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the deposits. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [Array<(DepositListResponse, Integer, Hash)>] DepositListResponse data, response status code and response headers
    def get_deposits_by_status_with_http_info(current_status, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_deposits_by_status ...'
      end
      # verify the required parameter 'current_status' is set
      if @api_client.config.client_side_validation && current_status.nil?
        fail ArgumentError, "Missing the required parameter 'current_status' when calling PayoutsApi.get_deposits_by_status"
      end
      # resource path
      local_var_path = '/payouts/v1/deposits/status/{currentStatus}'.sub('{' + 'currentStatus' + '}', CGI.escape(current_status.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DepositListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_deposits_by_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all disbursement transactions matching given correlation id.
    # @param client_correlation_id [String] Correlation identifier assigned to one or more disbursements by the Marketplace
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [DisbursementListResponse]
    def get_disbursements_by_client_correlation_id(client_correlation_id, opts = {})
      data, _status_code, _headers = get_disbursements_by_client_correlation_id_with_http_info(client_correlation_id, opts)
      data
    end

    # Returns all disbursement transactions matching given correlation id.
    # @param client_correlation_id [String] Correlation identifier assigned to one or more disbursements by the Marketplace
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(DisbursementListResponse, Integer, Hash)>] DisbursementListResponse data, response status code and response headers
    def get_disbursements_by_client_correlation_id_with_http_info(client_correlation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_disbursements_by_client_correlation_id ...'
      end
      # verify the required parameter 'client_correlation_id' is set
      if @api_client.config.client_side_validation && client_correlation_id.nil?
        fail ArgumentError, "Missing the required parameter 'client_correlation_id' when calling PayoutsApi.get_disbursements_by_client_correlation_id"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/correlation/{clientCorrelationId}'.sub('{' + 'clientCorrelationId' + '}', CGI.escape(client_correlation_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DisbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_disbursements_by_client_correlation_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all disbursement transactions matching given unique id.
    # @param client_unique_txn_id [String] Alternate key for a single disbursement record (assigned by Marketplace)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [DisbursementListResponse]
    def get_disbursements_by_client_unique_txn_id(client_unique_txn_id, opts = {})
      data, _status_code, _headers = get_disbursements_by_client_unique_txn_id_with_http_info(client_unique_txn_id, opts)
      data
    end

    # Returns all disbursement transactions matching given unique id.
    # @param client_unique_txn_id [String] Alternate key for a single disbursement record (assigned by Marketplace)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(DisbursementListResponse, Integer, Hash)>] DisbursementListResponse data, response status code and response headers
    def get_disbursements_by_client_unique_txn_id_with_http_info(client_unique_txn_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_disbursements_by_client_unique_txn_id ...'
      end
      # verify the required parameter 'client_unique_txn_id' is set
      if @api_client.config.client_side_validation && client_unique_txn_id.nil?
        fail ArgumentError, "Missing the required parameter 'client_unique_txn_id' when calling PayoutsApi.get_disbursements_by_client_unique_txn_id"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/clientId/{clientUniqueTxnId}'.sub('{' + 'clientUniqueTxnId' + '}', CGI.escape(client_unique_txn_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DisbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_disbursements_by_client_unique_txn_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all disbursement transactions matching given contract id.
    # @param contract_id [String] Primary identifier used to designate a payee (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [DisbursementListResponse]
    def get_disbursements_by_contract_id(contract_id, opts = {})
      data, _status_code, _headers = get_disbursements_by_contract_id_with_http_info(contract_id, opts)
      data
    end

    # Returns all disbursement transactions matching given contract id.
    # @param contract_id [String] Primary identifier used to designate a payee (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(DisbursementListResponse, Integer, Hash)>] DisbursementListResponse data, response status code and response headers
    def get_disbursements_by_contract_id_with_http_info(contract_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_disbursements_by_contract_id ...'
      end
      # verify the required parameter 'contract_id' is set
      if @api_client.config.client_side_validation && contract_id.nil?
        fail ArgumentError, "Missing the required parameter 'contract_id' when calling PayoutsApi.get_disbursements_by_contract_id"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/contract/{contractId}'.sub('{' + 'contractId' + '}', CGI.escape(contract_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DisbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_disbursements_by_contract_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all disbursement transactions matching given correlation id and status.
    # @param client_correlation_id [String] Correlation identifier assigned to one or more disbursements by the Marketplace
    # @param current_status [String] Current disbursement status
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [DisbursementListResponse]
    def get_disbursements_by_correlation_id_and_status(client_correlation_id, current_status, opts = {})
      data, _status_code, _headers = get_disbursements_by_correlation_id_and_status_with_http_info(client_correlation_id, current_status, opts)
      data
    end

    # Returns all disbursement transactions matching given correlation id and status.
    # @param client_correlation_id [String] Correlation identifier assigned to one or more disbursements by the Marketplace
    # @param current_status [String] Current disbursement status
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(DisbursementListResponse, Integer, Hash)>] DisbursementListResponse data, response status code and response headers
    def get_disbursements_by_correlation_id_and_status_with_http_info(client_correlation_id, current_status, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_disbursements_by_correlation_id_and_status ...'
      end
      # verify the required parameter 'client_correlation_id' is set
      if @api_client.config.client_side_validation && client_correlation_id.nil?
        fail ArgumentError, "Missing the required parameter 'client_correlation_id' when calling PayoutsApi.get_disbursements_by_correlation_id_and_status"
      end
      # verify the required parameter 'current_status' is set
      if @api_client.config.client_side_validation && current_status.nil?
        fail ArgumentError, "Missing the required parameter 'current_status' when calling PayoutsApi.get_disbursements_by_correlation_id_and_status"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/correlation/{clientCorrelationId}/status/{currentStatus}'.sub('{' + 'clientCorrelationId' + '}', CGI.escape(client_correlation_id.to_s).gsub('%2F', '/')).sub('{' + 'currentStatus' + '}', CGI.escape(current_status.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DisbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_disbursements_by_correlation_id_and_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all disbursement transactions matching given contract id.
    # @param currency [String] The currency for a set of disbursements (EUR, GBP, USD)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [DisbursementListResponse]
    def get_disbursements_by_currency(currency, opts = {})
      data, _status_code, _headers = get_disbursements_by_currency_with_http_info(currency, opts)
      data
    end

    # Returns all disbursement transactions matching given contract id.
    # @param currency [String] The currency for a set of disbursements (EUR, GBP, USD)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(DisbursementListResponse, Integer, Hash)>] DisbursementListResponse data, response status code and response headers
    def get_disbursements_by_currency_with_http_info(currency, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_disbursements_by_currency ...'
      end
      # verify the required parameter 'currency' is set
      if @api_client.config.client_side_validation && currency.nil?
        fail ArgumentError, "Missing the required parameter 'currency' when calling PayoutsApi.get_disbursements_by_currency"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/currency/{currency}'.sub('{' + 'currency' + '}', CGI.escape(currency.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DisbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_disbursements_by_currency\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all disbursement transactions matching given contract id.
    # @param payee_instrument_id [String] Primary identifier used to designate a payment instrument (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [DisbursementListResponse]
    def get_disbursements_by_instrument_id(payee_instrument_id, opts = {})
      data, _status_code, _headers = get_disbursements_by_instrument_id_with_http_info(payee_instrument_id, opts)
      data
    end

    # Returns all disbursement transactions matching given contract id.
    # @param payee_instrument_id [String] Primary identifier used to designate a payment instrument (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(DisbursementListResponse, Integer, Hash)>] DisbursementListResponse data, response status code and response headers
    def get_disbursements_by_instrument_id_with_http_info(payee_instrument_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_disbursements_by_instrument_id ...'
      end
      # verify the required parameter 'payee_instrument_id' is set
      if @api_client.config.client_side_validation && payee_instrument_id.nil?
        fail ArgumentError, "Missing the required parameter 'payee_instrument_id' when calling PayoutsApi.get_disbursements_by_instrument_id"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/instrument/{payeeInstrumentId}'.sub('{' + 'payeeInstrumentId' + '}', CGI.escape(payee_instrument_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DisbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_disbursements_by_instrument_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all disbursement transactions matching given order id.
    # @param order_id [String] Group identifer for a set of disbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [DisbursementListResponse]
    def get_disbursements_by_order_id(order_id, opts = {})
      data, _status_code, _headers = get_disbursements_by_order_id_with_http_info(order_id, opts)
      data
    end

    # Returns all disbursement transactions matching given order id.
    # @param order_id [String] Group identifer for a set of disbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(DisbursementListResponse, Integer, Hash)>] DisbursementListResponse data, response status code and response headers
    def get_disbursements_by_order_id_with_http_info(order_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_disbursements_by_order_id ...'
      end
      # verify the required parameter 'order_id' is set
      if @api_client.config.client_side_validation && order_id.nil?
        fail ArgumentError, "Missing the required parameter 'order_id' when calling PayoutsApi.get_disbursements_by_order_id"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/order/{orderId}'.sub('{' + 'orderId' + '}', CGI.escape(order_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DisbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_disbursements_by_order_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all disbursement transactions matching given contract id.
    # @param payee_party_id [String] Primary identifier used to designate a payment recipient (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [DisbursementListResponse]
    def get_disbursements_by_party_id(payee_party_id, opts = {})
      data, _status_code, _headers = get_disbursements_by_party_id_with_http_info(payee_party_id, opts)
      data
    end

    # Returns all disbursement transactions matching given contract id.
    # @param payee_party_id [String] Primary identifier used to designate a payment recipient (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(DisbursementListResponse, Integer, Hash)>] DisbursementListResponse data, response status code and response headers
    def get_disbursements_by_party_id_with_http_info(payee_party_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_disbursements_by_party_id ...'
      end
      # verify the required parameter 'payee_party_id' is set
      if @api_client.config.client_side_validation && payee_party_id.nil?
        fail ArgumentError, "Missing the required parameter 'payee_party_id' when calling PayoutsApi.get_disbursements_by_party_id"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/party/{payeePartyId}'.sub('{' + 'payeePartyId' + '}', CGI.escape(payee_party_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DisbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_disbursements_by_party_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all disbursement transactions matching given current status.
    # @param current_status [String] Current disbursement status
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [DisbursementListResponse]
    def get_disbursements_by_status(current_status, opts = {})
      data, _status_code, _headers = get_disbursements_by_status_with_http_info(current_status, opts)
      data
    end

    # Returns all disbursement transactions matching given current status.
    # @param current_status [String] Current disbursement status
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date From date. Format YYYY-MM-DD
    # @option opts [String] :to_date To date. Format YYYY-MM-DD
    # @option opts [String] :marketplace Optional Marketplace Id to filter the disbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(DisbursementListResponse, Integer, Hash)>] DisbursementListResponse data, response status code and response headers
    def get_disbursements_by_status_with_http_info(current_status, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_disbursements_by_status ...'
      end
      # verify the required parameter 'current_status' is set
      if @api_client.config.client_side_validation && current_status.nil?
        fail ArgumentError, "Missing the required parameter 'current_status' when calling PayoutsApi.get_disbursements_by_status"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/status/{currentStatus}'.sub('{' + 'currentStatus' + '}', CGI.escape(current_status.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fromDate'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'toDate'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DisbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_disbursements_by_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    #                      Returns the disbursement detail and status history for the given transactionId.
    # @param transaction_id [String] Primary key for a single disbursement record (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @return [Disbursement]
    def get_disbursements_by_txn_id(transaction_id, opts = {})
      data, _status_code, _headers = get_disbursements_by_txn_id_with_http_info(transaction_id, opts)
      data
    end

    #                      Returns the disbursement detail and status history for the given transactionId.
    # @param transaction_id [String] Primary key for a single disbursement record (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @return [Array<(Disbursement, Integer, Hash)>] Disbursement data, response status code and response headers
    def get_disbursements_by_txn_id_with_http_info(transaction_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_disbursements_by_txn_id ...'
      end
      # verify the required parameter 'transaction_id' is set
      if @api_client.config.client_side_validation && transaction_id.nil?
        fail ArgumentError, "Missing the required parameter 'transaction_id' when calling PayoutsApi.get_disbursements_by_txn_id"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/{transactionId}'.sub('{' + 'transactionId' + '}', CGI.escape(transaction_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Disbursement' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_disbursements_by_txn_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    #                      Returns the disbursement detail and status history for the given transactionId.
    # @param transaction_id [String] Primary key for a single disbursement record (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @return [Reimbursement]
    def get_reimbursement(transaction_id, opts = {})
      data, _status_code, _headers = get_reimbursement_with_http_info(transaction_id, opts)
      data
    end

    #                      Returns the disbursement detail and status history for the given transactionId.
    # @param transaction_id [String] Primary key for a single disbursement record (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @return [Array<(Reimbursement, Integer, Hash)>] Reimbursement data, response status code and response headers
    def get_reimbursement_with_http_info(transaction_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_reimbursement ...'
      end
      # verify the required parameter 'transaction_id' is set
      if @api_client.config.client_side_validation && transaction_id.nil?
        fail ArgumentError, "Missing the required parameter 'transaction_id' when calling PayoutsApi.get_reimbursement"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/{transactionId}'.sub('{' + 'transactionId' + '}', CGI.escape(transaction_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Reimbursement' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_reimbursement\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all reimbursement transactions matching given contract .
    # @param current_status [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param contract_id [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [ReimbursementListResponse]
    def get_reimbursements_by_contract_id(current_status, contract_id, opts = {})
      data, _status_code, _headers = get_reimbursements_by_contract_id_with_http_info(current_status, contract_id, opts)
      data
    end

    # Returns all reimbursement transactions matching given contract .
    # @param current_status [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param contract_id [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(ReimbursementListResponse, Integer, Hash)>] ReimbursementListResponse data, response status code and response headers
    def get_reimbursements_by_contract_id_with_http_info(current_status, contract_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_reimbursements_by_contract_id ...'
      end
      # verify the required parameter 'current_status' is set
      if @api_client.config.client_side_validation && current_status.nil?
        fail ArgumentError, "Missing the required parameter 'current_status' when calling PayoutsApi.get_reimbursements_by_contract_id"
      end
      # verify the required parameter 'contract_id' is set
      if @api_client.config.client_side_validation && contract_id.nil?
        fail ArgumentError, "Missing the required parameter 'contract_id' when calling PayoutsApi.get_reimbursements_by_contract_id"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/contract/{contractId}'.sub('{' + 'currentStatus' + '}', CGI.escape(current_status.to_s).gsub('%2F', '/')).sub('{' + 'contractId' + '}', CGI.escape(contract_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ReimbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_reimbursements_by_contract_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all reimbursement transactions matching given correlation .
    # @param client_correlation_id [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [ReimbursementListResponse]
    def get_reimbursements_by_correlation_id(client_correlation_id, opts = {})
      data, _status_code, _headers = get_reimbursements_by_correlation_id_with_http_info(client_correlation_id, opts)
      data
    end

    # Returns all reimbursement transactions matching given correlation .
    # @param client_correlation_id [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(ReimbursementListResponse, Integer, Hash)>] ReimbursementListResponse data, response status code and response headers
    def get_reimbursements_by_correlation_id_with_http_info(client_correlation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_reimbursements_by_correlation_id ...'
      end
      # verify the required parameter 'client_correlation_id' is set
      if @api_client.config.client_side_validation && client_correlation_id.nil?
        fail ArgumentError, "Missing the required parameter 'client_correlation_id' when calling PayoutsApi.get_reimbursements_by_correlation_id"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/correlation/{clientCorrelationId}'.sub('{' + 'clientCorrelationId' + '}', CGI.escape(client_correlation_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ReimbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_reimbursements_by_correlation_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all pool activities matching given client correlation id and status.
    # @param client_correlation_id [String] Correlation identifier assigned to one or more reimbursements by the Marketplace
    # @param current_status [String] Current reimbursement status of the pool activity
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [ReimbursementListResponse]
    def get_reimbursements_by_correlation_id_and_status(client_correlation_id, current_status, opts = {})
      data, _status_code, _headers = get_reimbursements_by_correlation_id_and_status_with_http_info(client_correlation_id, current_status, opts)
      data
    end

    # Returns all pool activities matching given client correlation id and status.
    # @param client_correlation_id [String] Correlation identifier assigned to one or more reimbursements by the Marketplace
    # @param current_status [String] Current reimbursement status of the pool activity
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default marketplace                        from app token will be used if applicable.
    # @return [Array<(ReimbursementListResponse, Integer, Hash)>] ReimbursementListResponse data, response status code and response headers
    def get_reimbursements_by_correlation_id_and_status_with_http_info(client_correlation_id, current_status, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_reimbursements_by_correlation_id_and_status ...'
      end
      # verify the required parameter 'client_correlation_id' is set
      if @api_client.config.client_side_validation && client_correlation_id.nil?
        fail ArgumentError, "Missing the required parameter 'client_correlation_id' when calling PayoutsApi.get_reimbursements_by_correlation_id_and_status"
      end
      # verify the required parameter 'current_status' is set
      if @api_client.config.client_side_validation && current_status.nil?
        fail ArgumentError, "Missing the required parameter 'current_status' when calling PayoutsApi.get_reimbursements_by_correlation_id_and_status"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/correlation/{clientCorrelationId}/status/{currentStatus}'.sub('{' + 'clientCorrelationId' + '}', CGI.escape(client_correlation_id.to_s).gsub('%2F', '/')).sub('{' + 'currentStatus' + '}', CGI.escape(current_status.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ReimbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_reimbursements_by_correlation_id_and_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all reimbursement transactions matching given currency .
    # @param currency [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [ReimbursementListResponse]
    def get_reimbursements_by_currency(currency, opts = {})
      data, _status_code, _headers = get_reimbursements_by_currency_with_http_info(currency, opts)
      data
    end

    # Returns all reimbursement transactions matching given currency .
    # @param currency [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(ReimbursementListResponse, Integer, Hash)>] ReimbursementListResponse data, response status code and response headers
    def get_reimbursements_by_currency_with_http_info(currency, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_reimbursements_by_currency ...'
      end
      # verify the required parameter 'currency' is set
      if @api_client.config.client_side_validation && currency.nil?
        fail ArgumentError, "Missing the required parameter 'currency' when calling PayoutsApi.get_reimbursements_by_currency"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/currency/{currency}'.sub('{' + 'currency' + '}', CGI.escape(currency.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ReimbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_reimbursements_by_currency\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all reimbursement transactions matching given clientId .
    # @param client_unique_txn_id [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [ReimbursementListResponse]
    def get_reimbursements_by_current_status(client_unique_txn_id, opts = {})
      data, _status_code, _headers = get_reimbursements_by_current_status_with_http_info(client_unique_txn_id, opts)
      data
    end

    # Returns all reimbursement transactions matching given clientId .
    # @param client_unique_txn_id [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(ReimbursementListResponse, Integer, Hash)>] ReimbursementListResponse data, response status code and response headers
    def get_reimbursements_by_current_status_with_http_info(client_unique_txn_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_reimbursements_by_current_status ...'
      end
      # verify the required parameter 'client_unique_txn_id' is set
      if @api_client.config.client_side_validation && client_unique_txn_id.nil?
        fail ArgumentError, "Missing the required parameter 'client_unique_txn_id' when calling PayoutsApi.get_reimbursements_by_current_status"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/clientId/{clientUniqueTxnId}'.sub('{' + 'clientUniqueTxnId' + '}', CGI.escape(client_unique_txn_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ReimbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_reimbursements_by_current_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all reimbursement transactions matching given instrument .
    # @param payee_instrument_id [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [ReimbursementListResponse]
    def get_reimbursements_by_instrument(payee_instrument_id, opts = {})
      data, _status_code, _headers = get_reimbursements_by_instrument_with_http_info(payee_instrument_id, opts)
      data
    end

    # Returns all reimbursement transactions matching given instrument .
    # @param payee_instrument_id [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(ReimbursementListResponse, Integer, Hash)>] ReimbursementListResponse data, response status code and response headers
    def get_reimbursements_by_instrument_with_http_info(payee_instrument_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_reimbursements_by_instrument ...'
      end
      # verify the required parameter 'payee_instrument_id' is set
      if @api_client.config.client_side_validation && payee_instrument_id.nil?
        fail ArgumentError, "Missing the required parameter 'payee_instrument_id' when calling PayoutsApi.get_reimbursements_by_instrument"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/instrument/{payeeInstrumentId}'.sub('{' + 'payeeInstrumentId' + '}', CGI.escape(payee_instrument_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ReimbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_reimbursements_by_instrument\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all reimbursement transactions matching given order .
    # @param order_id [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [ReimbursementListResponse]
    def get_reimbursements_by_order_id(order_id, opts = {})
      data, _status_code, _headers = get_reimbursements_by_order_id_with_http_info(order_id, opts)
      data
    end

    # Returns all reimbursement transactions matching given order .
    # @param order_id [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(ReimbursementListResponse, Integer, Hash)>] ReimbursementListResponse data, response status code and response headers
    def get_reimbursements_by_order_id_with_http_info(order_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_reimbursements_by_order_id ...'
      end
      # verify the required parameter 'order_id' is set
      if @api_client.config.client_side_validation && order_id.nil?
        fail ArgumentError, "Missing the required parameter 'order_id' when calling PayoutsApi.get_reimbursements_by_order_id"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/order/{orderId}'.sub('{' + 'orderId' + '}', CGI.escape(order_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ReimbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_reimbursements_by_order_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all reimbursement transactions matching given party .
    # @param payee_party_id [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [ReimbursementListResponse]
    def get_reimbursements_by_party_id(payee_party_id, opts = {})
      data, _status_code, _headers = get_reimbursements_by_party_id_with_http_info(payee_party_id, opts)
      data
    end

    # Returns all reimbursement transactions matching given party .
    # @param payee_party_id [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(ReimbursementListResponse, Integer, Hash)>] ReimbursementListResponse data, response status code and response headers
    def get_reimbursements_by_party_id_with_http_info(payee_party_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_reimbursements_by_party_id ...'
      end
      # verify the required parameter 'payee_party_id' is set
      if @api_client.config.client_side_validation && payee_party_id.nil?
        fail ArgumentError, "Missing the required parameter 'payee_party_id' when calling PayoutsApi.get_reimbursements_by_party_id"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/party/{payeePartyId}'.sub('{' + 'payeePartyId' + '}', CGI.escape(payee_party_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ReimbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_reimbursements_by_party_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns all reimbursement transactions matching given status .
    # @param current_status [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [ReimbursementListResponse]
    def get_reimbursements_by_status(current_status, opts = {})
      data, _status_code, _headers = get_reimbursements_by_status_with_http_info(current_status, opts)
      data
    end

    # Returns all reimbursement transactions matching given status .
    # @param current_status [String] Group identifer for a set of reimbursements created via a single API request                        (assigned by YapStone)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :marketplace Optional Marketplace Id to filter the reimbursements. If not passed, default                        marketplace from app token will be used if applicable.
    # @return [Array<(ReimbursementListResponse, Integer, Hash)>] ReimbursementListResponse data, response status code and response headers
    def get_reimbursements_by_status_with_http_info(current_status, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.get_reimbursements_by_status ...'
      end
      # verify the required parameter 'current_status' is set
      if @api_client.config.client_side_validation && current_status.nil?
        fail ArgumentError, "Missing the required parameter 'current_status' when calling PayoutsApi.get_reimbursements_by_status"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/status/{currentStatus}'.sub('{' + 'currentStatus' + '}', CGI.escape(current_status.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'marketplace'] = opts[:'marketplace'] if !opts[:'marketplace'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ReimbursementListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#get_reimbursements_by_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    #                      Reverse Disbursement - Submits a full (or partial) disbursement for funds that were originally                     retrieved via the given transactionId recapture order. The resulting transactionId represents the                     linked disbursement.
    # @param transaction_id [String] Primary key for a single disbursement record (assigned by YapStone)
    # @param reverse_disbursement_request [ReverseDisbursementRequest] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def reverse_disbursement(transaction_id, reverse_disbursement_request, opts = {})
      reverse_disbursement_with_http_info(transaction_id, reverse_disbursement_request, opts)
      nil
    end

    #                      Reverse Disbursement - Submits a full (or partial) disbursement for funds that were originally                     retrieved via the given transactionId recapture order. The resulting transactionId represents the                     linked disbursement.
    # @param transaction_id [String] Primary key for a single disbursement record (assigned by YapStone)
    # @param reverse_disbursement_request [ReverseDisbursementRequest] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def reverse_disbursement_with_http_info(transaction_id, reverse_disbursement_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.reverse_disbursement ...'
      end
      # verify the required parameter 'transaction_id' is set
      if @api_client.config.client_side_validation && transaction_id.nil?
        fail ArgumentError, "Missing the required parameter 'transaction_id' when calling PayoutsApi.reverse_disbursement"
      end
      # verify the required parameter 'reverse_disbursement_request' is set
      if @api_client.config.client_side_validation && reverse_disbursement_request.nil?
        fail ArgumentError, "Missing the required parameter 'reverse_disbursement_request' when calling PayoutsApi.reverse_disbursement"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements/{transactionId}/reverse'.sub('{' + 'transactionId' + '}', CGI.escape(transaction_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(reverse_disbursement_request) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#reverse_disbursement\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    #                      Reverse Reimbursement - Submits a full (or partial) disbursement for funds that were originally                     retrieved via the given transactionId recapture order. The resulting transactionId represents the                     linked reimbursement.
    # @param transaction_id [String] Primary key for a single reimbursement record (assigned by YapStone)
    # @param reverse_reimbursement_request [ReverseReimbursementRequest] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def reverse_reimbursement(transaction_id, reverse_reimbursement_request, opts = {})
      reverse_reimbursement_with_http_info(transaction_id, reverse_reimbursement_request, opts)
      nil
    end

    #                      Reverse Reimbursement - Submits a full (or partial) disbursement for funds that were originally                     retrieved via the given transactionId recapture order. The resulting transactionId represents the                     linked reimbursement.
    # @param transaction_id [String] Primary key for a single reimbursement record (assigned by YapStone)
    # @param reverse_reimbursement_request [ReverseReimbursementRequest] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def reverse_reimbursement_with_http_info(transaction_id, reverse_reimbursement_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.reverse_reimbursement ...'
      end
      # verify the required parameter 'transaction_id' is set
      if @api_client.config.client_side_validation && transaction_id.nil?
        fail ArgumentError, "Missing the required parameter 'transaction_id' when calling PayoutsApi.reverse_reimbursement"
      end
      # verify the required parameter 'reverse_reimbursement_request' is set
      if @api_client.config.client_side_validation && reverse_reimbursement_request.nil?
        fail ArgumentError, "Missing the required parameter 'reverse_reimbursement_request' when calling PayoutsApi.reverse_reimbursement"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements/{transactionId}/reverse'.sub('{' + 'transactionId' + '}', CGI.escape(transaction_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(reverse_reimbursement_request) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#reverse_reimbursement\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    #                      Provides instructions from the Marketplace for payments to be distributed to one or more                     Payees. Disbursement requests are grouped by currency, given that the funding pools are also                     segregated in this manner. If the corresponding pool was funded in advance, the disbursements                     will be processed on a same-day basis. Otherwise the disbursement requests will be queued for                     later processing as funds become available. Response is organized in two collections (accepted                     and rejected) to distinguish successful and failed items.
    # @param disbursement_request [DisbursementRequest] Provides instructions from the Marketplace for payments to be distributed to one                        or more Payees. Disbursement requests are grouped by currency, given that the funding pools are                        also segregated in this manner. If the corresponding pool was funded in advance, the                        disbursements will be processed on a same-day basis. Otherwise the disbursement requests will                        be queued for later processing as funds become available. Response is organized in two                        collections (&#x60;accepted&#x60; and &#x60;rejected&#x60;) to distinguish successful and failed items.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def submit_disbursements_for_payees(disbursement_request, opts = {})
      submit_disbursements_for_payees_with_http_info(disbursement_request, opts)
      nil
    end

    #                      Provides instructions from the Marketplace for payments to be distributed to one or more                     Payees. Disbursement requests are grouped by currency, given that the funding pools are also                     segregated in this manner. If the corresponding pool was funded in advance, the disbursements                     will be processed on a same-day basis. Otherwise the disbursement requests will be queued for                     later processing as funds become available. Response is organized in two collections (accepted                     and rejected) to distinguish successful and failed items.
    # @param disbursement_request [DisbursementRequest] Provides instructions from the Marketplace for payments to be distributed to one                        or more Payees. Disbursement requests are grouped by currency, given that the funding pools are                        also segregated in this manner. If the corresponding pool was funded in advance, the                        disbursements will be processed on a same-day basis. Otherwise the disbursement requests will                        be queued for later processing as funds become available. Response is organized in two                        collections (&#x60;accepted&#x60; and &#x60;rejected&#x60;) to distinguish successful and failed items.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def submit_disbursements_for_payees_with_http_info(disbursement_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.submit_disbursements_for_payees ...'
      end
      # verify the required parameter 'disbursement_request' is set
      if @api_client.config.client_side_validation && disbursement_request.nil?
        fail ArgumentError, "Missing the required parameter 'disbursement_request' when calling PayoutsApi.submit_disbursements_for_payees"
      end
      # resource path
      local_var_path = '/payouts/v1/disbursements'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(disbursement_request) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#submit_disbursements_for_payees\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # @param reimbursement_request [ReimbursementRequest] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def submit_reimbursements(reimbursement_request, opts = {})
      submit_reimbursements_with_http_info(reimbursement_request, opts)
      nil
    end

    # @param reimbursement_request [ReimbursementRequest] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def submit_reimbursements_with_http_info(reimbursement_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.submit_reimbursements ...'
      end
      # verify the required parameter 'reimbursement_request' is set
      if @api_client.config.client_side_validation && reimbursement_request.nil?
        fail ArgumentError, "Missing the required parameter 'reimbursement_request' when calling PayoutsApi.submit_reimbursements"
      end
      # resource path
      local_var_path = '/payouts/v1/reimbursements'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(reimbursement_request) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#submit_reimbursements\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    #                      Allows a Marketplace to update the details for a pending deposit advice to correct these values                     relative to the original post operation. Note that the new values will overwrite the existing                     deposit, and all must be provided by the caller (presumably after a corresponding get operation).                     If the deposit has already been processed then the update request will be rejected                     (400 Bad request).
    # @param deposit_id [String] Primary key for a single deposit record (assigned by YapStone)
    # @param deposit_detail [DepositDetail] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def update_deposit(deposit_id, deposit_detail, opts = {})
      update_deposit_with_http_info(deposit_id, deposit_detail, opts)
      nil
    end

    #                      Allows a Marketplace to update the details for a pending deposit advice to correct these values                     relative to the original post operation. Note that the new values will overwrite the existing                     deposit, and all must be provided by the caller (presumably after a corresponding get operation).                     If the deposit has already been processed then the update request will be rejected                     (400 Bad request).
    # @param deposit_id [String] Primary key for a single deposit record (assigned by YapStone)
    # @param deposit_detail [DepositDetail] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def update_deposit_with_http_info(deposit_id, deposit_detail, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutsApi.update_deposit ...'
      end
      # verify the required parameter 'deposit_id' is set
      if @api_client.config.client_side_validation && deposit_id.nil?
        fail ArgumentError, "Missing the required parameter 'deposit_id' when calling PayoutsApi.update_deposit"
      end
      # verify the required parameter 'deposit_detail' is set
      if @api_client.config.client_side_validation && deposit_detail.nil?
        fail ArgumentError, "Missing the required parameter 'deposit_detail' when calling PayoutsApi.update_deposit"
      end
      # resource path
      local_var_path = '/payouts/v1/deposits/{depositId}'.sub('{' + 'depositId' + '}', CGI.escape(deposit_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deposit_detail) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutsApi#update_deposit\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
