=begin
#Payout Orchestrator API

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.3

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  class FundingPool
    attr_accessor :pool_id

    attr_accessor :market_place_id

    attr_accessor :currency

    attr_accessor :good_funds_balance

    attr_accessor :debit_hold_amount

    attr_accessor :credit_hold_amount

    attr_accessor :pending_reimbursement_amount

    attr_accessor :modified_date

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pool_id' => :'poolId',
        :'market_place_id' => :'marketPlaceId',
        :'currency' => :'currency',
        :'good_funds_balance' => :'goodFundsBalance',
        :'debit_hold_amount' => :'debitHoldAmount',
        :'credit_hold_amount' => :'creditHoldAmount',
        :'pending_reimbursement_amount' => :'pendingReimbursementAmount',
        :'modified_date' => :'modifiedDate'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'pool_id' => :'String',
        :'market_place_id' => :'String',
        :'currency' => :'String',
        :'good_funds_balance' => :'Integer',
        :'debit_hold_amount' => :'Integer',
        :'credit_hold_amount' => :'Integer',
        :'pending_reimbursement_amount' => :'Integer',
        :'modified_date' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::FundingPool` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::FundingPool`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'pool_id')
        self.pool_id = attributes[:'pool_id']
      end

      if attributes.key?(:'market_place_id')
        self.market_place_id = attributes[:'market_place_id']
      end

      if attributes.key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.key?(:'good_funds_balance')
        self.good_funds_balance = attributes[:'good_funds_balance']
      end

      if attributes.key?(:'debit_hold_amount')
        self.debit_hold_amount = attributes[:'debit_hold_amount']
      end

      if attributes.key?(:'credit_hold_amount')
        self.credit_hold_amount = attributes[:'credit_hold_amount']
      end

      if attributes.key?(:'pending_reimbursement_amount')
        self.pending_reimbursement_amount = attributes[:'pending_reimbursement_amount']
      end

      if attributes.key?(:'modified_date')
        self.modified_date = attributes[:'modified_date']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pool_id == o.pool_id &&
          market_place_id == o.market_place_id &&
          currency == o.currency &&
          good_funds_balance == o.good_funds_balance &&
          debit_hold_amount == o.debit_hold_amount &&
          credit_hold_amount == o.credit_hold_amount &&
          pending_reimbursement_amount == o.pending_reimbursement_amount &&
          modified_date == o.modified_date
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [pool_id, market_place_id, currency, good_funds_balance, debit_hold_amount, credit_hold_amount, pending_reimbursement_amount, modified_date].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
